'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.rxDucksMiddleware = rxDucksMiddleware;

var _Subject = require('rxjs/Subject');

var _from = require('rxjs/observable/from');

function rxDucksMiddleware() {
  var actions = new _Subject.Subject();

  var middleware = function middleware(store) {
    return function (next) {
      return function (action) {
        if (typeof action === 'function') {
          var obs = (0, _from.from)(action(actions, store));
          var sub = obs.subscribe(next);
          actions.next(action);
          return sub;
        } else {
          return next(action);
        }
      };
    };
  };

  return middleware;
}